View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.filter.codec.statemachine;
    21
    22  import org.apache.mina.core.buffer.IoBuffer;
    23  import org.apache.mina.filter.codec.ProtocolDecoderException;
    24  import org.apache.mina.filter.codec.ProtocolDecoderOutput;
    25
    26  /**
    27   * {@link DecodingState} which decodes <code>short</code> values in big-endian
    28   * order (high bytes come first).
    29   *
    30   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    31   */
    32  public abstract class ShortIntegerDecodingState implements DecodingState {
    33
    34      private int highByte;
    35
    36      private int counter;
    37
    38      /**
    39       * {@inheritDoc}
    40       */
    41      public DecodingState decode(IoBuffer in, ProtocolDecoderOutput out) throws Exception {
    42
    43          while (in.hasRemaining()) {
    44              switch (counter) {
    45              case 0:
    46                  highByte = in.getUnsigned();
    47                  break;
    48              case 1:
    49                  counter = 0;
    50                  return finishDecode((short) ((highByte << 8) | in.getUnsigned()), out);
    51              default:
    52                  throw new InternalError();
    53              }
    54
    55              counter++;
    56          }
    57          return this;
    58      }
    59
    60      /**
    61       * {@inheritDoc}
    62       */
    63      public DecodingState finishDecode(ProtocolDecoderOutput out) throws Exception {
    64          throw new ProtocolDecoderException("Unexpected end of session while waiting for a short integer.");
    65      }
    66
    67      /**
    68       * Invoked when this state has consumed a complete <code>short</code>.
    69       *
    70       * @param value the short.
    71       * @param out the current {@link ProtocolDecoderOutput} used to write
    72       *        decoded messages.
    73       * @return the next state if a state transition was triggered (use
    74       *         <code>this</code> for loop transitions) or <code>null</code> if
    75       *         the state machine has reached its end.
    76       * @throws Exception if the read data violated protocol specification.
    77       */
    78      protected abstract DecodingState finishDecode(short value, ProtocolDecoderOutput out) throws Exception;
    79  }